import type { NodePath } from '@babel/traverse';
import * as t from '@babel/types';
import type { State } from '../types';
/**
 * Appends runtime import to code. If it is already present, it will append import specifiers
 * to already imported declaration path else it will create fresh import declaration path
 * with runtime import specifiers.
 *
 * @param path ImportDeclaration node path
 */
export declare const appendRuntimeImports: (path: NodePath<t.Program>, state: State) => void;
