"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildDisplayName = void 0;
const template_1 = __importDefault(require("@babel/template"));
const displayNameTemplate = (0, template_1.default)(`
if (process.env.NODE_ENV !== 'production') {
  %%identifier%%.displayName = %%displayName%%;
}
`, { syntacticPlaceholders: true });
/**
 * Assigns a display name string to the identifier.
 *
 * @param identifier
 * @param displayName
 * @returns
 */
const buildDisplayName = (identifier, displayName = identifier) => {
    return displayNameTemplate({
        identifier,
        displayName: `'${displayName}'`,
    });
};
exports.buildDisplayName = buildDisplayName;
//# sourceMappingURL=build-display-name.js.map