"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compressClassNamesForRuntime = void 0;
/**
 * Compress class names based on `classNameCompressionMap`.
 * The compressed class name has a format of `_aaaa_a`, which is expected by `ac`.
 * `aaaa` is the atomic group and `a` is the compressed name.
 */
const compressClassNamesForRuntime = (classNames, classNameCompressionMap) => {
    // If no classNameCompressionMap, return original class names.
    if (!classNameCompressionMap)
        return classNames;
    return classNames.map((className) => {
        const compressedClassName = classNameCompressionMap && classNameCompressionMap[className.slice(1)];
        return compressedClassName ? `_${className.slice(1, 5)}_${compressedClassName}` : className;
    });
};
exports.compressClassNamesForRuntime = compressClassNamesForRuntime;
//# sourceMappingURL=compress-class-names-for-runtime.js.map