import type { NodePath } from '@babel/traverse';
import * as t from '@babel/types';
/**
 * Converts all usage of props to a normalized format
 * For example:
 *
 * `(p) => p.width`
 * `({ width }) => width`
 * `({ width: w }) => w`
 * `({height, ...rest}) => rest.width`
 *
 * All become
 * `(props) => props.width`
 *
 * @param styledPath Path of the CSS source
 */
export declare const normalizePropsUsage: (styledPath: NodePath<t.TaggedTemplateExpression> | NodePath<t.CallExpression>) => void;
