"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.traverseMemberAccessPath = void 0;
const create_result_pair_1 = require("../../../create-result-pair");
const evaluate_path_1 = require("./evaluate-path");
const resolve_expression_1 = require("./resolve-expression");
const traverseMemberAccessPath = (expression, meta, expressionName, accessPath, memberExpression, evaluateExpression) => {
    const { value: resolvedExpression, meta: updatedMeta } = (0, resolve_expression_1.resolveExpressionInMember)(expression, meta, expressionName, memberExpression, evaluateExpression);
    if (accessPath.length) {
        const pathName = accessPath[0].name;
        const result = (0, evaluate_path_1.evaluatePath)(resolvedExpression, updatedMeta, pathName);
        return (0, exports.traverseMemberAccessPath)(result.value, result.meta, pathName, accessPath.slice(1), memberExpression, evaluateExpression);
    }
    return (0, create_result_pair_1.createResultPair)(resolvedExpression, updatedMeta);
};
exports.traverseMemberAccessPath = traverseMemberAccessPath;
//# sourceMappingURL=index.js.map